﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Identity;
using Props.Shared.Models;

namespace Props.Models
{
    public class ApplicationUser : IdentityUser
    {
        [Required]
        public virtual SearchOutline SearchOutline { get; private set; }
        [Required]
        public virtual ResultsPreferences ResultsPreferences { get; private set; }

        [Required]
        public virtual ApplicationPreferences ApplicationPreferences { get; private set; }

        public ApplicationUser()
        {
            SearchOutline = new SearchOutline();
            ResultsPreferences = new ResultsPreferences();
            ApplicationPreferences = new ApplicationPreferences();
        }

        public ApplicationUser(SearchOutline searchOutline, ResultsPreferences resultsPreferences, ApplicationPreferences applicationPreferences)
        {
            this.SearchOutline = searchOutline;
            this.ResultsPreferences = resultsPreferences;
            this.ApplicationPreferences = applicationPreferences;
        }
    }
}
